#ltlrangeconvert.py
#A script to change the range
#but keep MOST of the dynamics
#DISCLAIMER: Drastic range changes will remove the dynamics.
#Thanks to Dean Hickerson's algorithm!
#By Saka.
from decimal import *
import golly as g
getcontext().prec = 8
fullrule = g.getrule()
sections = fullrule.split(",")
r = sections[0]
b = sections[4]
s = sections[3]
c = sections[1]
m = sections[2]
n = sections[5]
#Filter n so :Txxx don't get involved
nlist = n.split(":")
npure = nlist[0]
#Aaand filter r so the R is gone
rpure = int(r[1])
#Getting bmin and bmax outta that string...
bpure = b.translate(None,"B")
blist = bpure.split("..")
bmin = int(blist[0])
bmax = int(blist[1])
#Now for smin and smax...
spure = s.translate(None,"S")
slist = spure.split("..")
smin = int(slist[0])
smax = int(slist[1])
#Input time
rangeto = int(g.getstring("Range to convert to?","5"))
rangetostr = str(rangeto)
#Now for calculations!
meaningoflife = (2*Decimal(rangeto)+1)**2/(2*Decimal(rpure)+1)**2
newbmin = str(int(round(bmin*meaningoflife))) #Huh. Decimal to number to integer to string
newbmax = str(int(round(bmax*meaningoflife)))
newsmin = str(int(round(smin*meaningoflife)))
newsmax = str(int(round(smax*meaningoflife)))
newrule = "R"+rangetostr+","+c+","+m+","+"S"+newsmin+".."+newsmax+","+"B"+newbmin+".."+newbmax+","+npure
g.setrule(newrule)
